package node

import (
	"context"

	v1 "k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

type KubernetesClient interface {
	ListNodes(ctx context.Context) ([]v1.Node, error)
	ListPodsByLabel(ctx context.Context, label *metav1.LabelSelector) ([]v1.Pod, error)
	CreatePod(ctx context.Context, namespace string, pod *v1.Pod) error
	DeletePod(ctx context.Context, namespace string, podName string) error
	WaitUntilCompleted(namespace string, podName string) error
	GetContainerLog(ctx context.Context, namespace string, podName string, containerName string) (string, error)
}
